Merge pull request #301 from directhex/master
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         array-init.cs           \
48         arraylist.cs            \
49         assemblyresolve_event.cs        \
50         assemblyresolve_event3.cs       \
51         checked.cs              \
52         char-isnumber.cs        \
53         create-instance.cs      \
54         field-layout.cs         \
55         pack-layout.cs          \
56         pack-bug.cs             \
57         hash-table.cs           \
58         test-ops.cs             \
59         obj.cs                  \
60         test-dup-mp.cs          \
61         string.cs               \
62         stringbuilder.cs        \
63         switch.cs               \
64         outparm.cs              \
65         delegate.cs             \
66         bitconverter.cs         \
67         exception.cs            \
68         exception2.cs           \
69         exception3.cs           \
70         exception4.cs           \
71         exception5.cs           \
72         exception6.cs           \
73         exception7.cs           \
74         exception8.cs           \
75         exception10.cs          \
76         exception11.cs          \
77         exception12.cs          \
78         exception13.cs          \
79         exception14.cs          \
80         exception15.cs          \
81         exception16.cs          \
82         exception17.cs          \
83         typeload-unaligned.cs   \
84         struct.cs               \
85         valuetype-gettype.cs    \
86         typeof-ptr.cs           \
87         static-constructor.cs   \
88         pinvoke.cs              \
89         pinvoke2.cs             \
90         pinvoke3.cs             \
91         pinvoke11.cs            \
92         pinvoke13.cs            \
93         pinvoke17.cs            \
94         invoke.cs               \
95         invoke2.cs              \
96         runtime-invoke.cs               \
97         invoke-string-ctors.cs          \
98         reinit.cs               \
99         box.cs                  \
100         array.cs                \
101         enum.cs                 \
102         enum2.cs                \
103         property.cs             \
104         enumcast.cs             \
105         assignable-tests.cs     \
106         array-cast.cs           \
107         array-subtype-attr.cs   \
108         cattr-compile.cs        \
109         cattr-field.cs          \
110         cattr-object.cs         \
111         custom-attr.cs          \
112         double-cast.cs          \
113         newobj-valuetype.cs     \
114         arraylist-clone.cs      \
115         setenv.cs               \
116         vtype.cs                \
117         isvaluetype.cs          \
118         iface6.cs               \
119         iface7.cs               \
120         ipaddress.cs            \
121         array-vt.cs             \
122         interface1.cs           \
123         reflection-enum.cs      \
124         reflection-prop.cs      \
125         reflection4.cs          \
126         reflection5.cs          \
127         reflection-const-field.cs \
128         many-locals.cs          \
129         string-compare.cs       \
130         test-prime.cs           \
131         params.cs               \
132         reflection.cs           \
133         interface.cs            \
134         iface.cs                \
135         iface2.cs               \
136         iface3.cs               \
137         iface4.cs               \
138         iface-large.cs          \
139         virtual-method.cs       \
140         intptrcast.cs           \
141         indexer.cs              \
142         stream.cs               \
143         console.cs              \
144         shift.cs                \
145         jit-int.cs              \
146         jit-uint.cs             \
147         jit-long.cs             \
148         long.cs                 \
149         jit-ulong.cs            \
150         jit-float.cs            \
151         pop.cs                  \
152         time.cs                 \
153         appdomain.cs        \
154         appdomain1.cs           \
155         appdomain2.cs           \
156         appdomain-client.cs     \
157         appdomain-unload.cs \
158         appdomain-async-invoke.cs       \
159         loader.cs       \
160         pointer.cs              \
161         hashcode.cs             \
162         delegate1.cs            \
163         delegate2.cs            \
164         delegate3.cs            \
165         delegate5.cs            \
166         delegate6.cs            \
167         delegate7.cs            \
168         delegate8.cs            \
169         delegate9.cs            \
170         remoting1.cs            \
171         remoting2.cs            \
172         remoting3.cs            \
173         remoting4.cs            \
174         remoting5.cs            \
175         largeexp.cs             \
176         largeexp2.cs            \
177         marshalbyref1.cs        \
178         static-ctor.cs          \
179         inctest.cs              \
180         bound.cs                \
181         array-invoke.cs         \
182         test-arr.cs             \
183         decimal.cs              \
184         decimal-array.cs        \
185         marshal.cs              \
186         marshal1.cs             \
187         marshal2.cs             \
188         marshal3.cs             \
189         marshal5.cs             \
190         marshal6.cs             \
191         marshal7.cs             \
192         marshal8.cs             \
193         marshal9.cs             \
194         marshalbool.cs          \
195         marshal-valuetypes.cs   \
196         test-byval-in-struct.cs \
197         thread.cs               \
198         thread5.cs              \
199         thread6.cs              \
200         thread-static.cs        \
201         thread-static-init.cs   \
202         context-static.cs       \
203         float-pop.cs            \
204         interfacecast.cs        \
205         array3.cs               \
206         classinit.cs            \
207         classinit2.cs           \
208         synchronized.cs         \
209         async_read.cs           \
210         threadpool.cs           \
211         threadpool1.cs          \
212         threadpool-exceptions1.cs \
213         threadpool-exceptions2.cs \
214         threadpool-exceptions3.cs \
215         threadpool-exceptions4.cs \
216         threadpool-exceptions5.cs \
217         threadpool-exceptions6.cs \
218         threadpool-exceptions7.cs \
219         base-definition.cs      \
220         bug-27420.cs            \
221         bug-47295.cs            \
222         bug-46781.cs            \
223         bug-48015.cs            \
224         bug-42136.cs            \
225         bug-59286.cs            \
226         bug-70561.cs            \
227         bug-78311.cs            \
228         bug-78653.cs            \
229         bug-78656.cs            \
230         bug-77127.cs            \
231         bug-323114.cs           \
232         interlocked.cs          \
233         cross-domain.cs         \
234         appdomain-exit.cs       \
235         delegate-async-exit.cs  \
236         delegate-delegate-exit.cs       \
237         delegate-exit.cs        \
238         finalizer-abort.cs      \
239         finalizer-exception.cs  \
240         finalizer-exit.cs       \
241         finalizer-thread.cs     \
242         main-exit.cs    \
243         main-returns-abort-resetabort.cs        \
244         main-returns-background-abort-resetabort.cs     \
245         main-returns-background-resetabort.cs   \
246         main-returns-background.cs      \
247         main-returns-background-change.cs       \
248         main-returns.cs         \
249         subthread-exit.cs       \
250         desweak.cs              \
251         cominterop.cs           \
252         exists.cs               \
253         handleref.cs    \
254         transparentproxy.cs \
255         dbnull-missing.cs       \
256         test-type-ctor.cs       \
257         soft-float-tests.cs     \
258         thread-exit.cs          \
259         finalize-parent.cs      \
260         assemblyresolve_event2.2.cs     \
261         interlocked-2.2.cs      \
262         pinvoke-2.2.cs          \
263         bug-78431.2.cs          \
264         bug-79684.2.cs          \
265         catch-generics.2.cs     \
266         event-get.2.cs          \
267         safehandle.2.cs         \
268         stackframes-async.2.cs          \
269         module-cctor-loader.2.cs        \
270         generics-invoke-byref.2.cs      \
271         generic-signature-compare.2.cs  \
272         generics-sharing.2.cs   \
273         shared-generic-methods.2.cs     \
274         shared-generic-synchronized.2.cs        \
275         generic-inlining.2.cs   \
276         generic-initobj.2.cs    \
277         generic-delegate.2.cs   \
278         generic-sizeof.2.cs     \
279         generic-virtual.2.cs    \
280         generic-interface-methods.2.cs  \
281         generic-array-type.2.cs \
282         generic-method-patching.2.cs    \
283         generic-static-methods.2.cs     \
284         generic-null-call.2.cs  \
285         generic-special.2.cs    \
286         generic-exceptions.2.cs \
287         generic-virtual2.2.cs   \
288         generic-valuetype-interface.2.cs        \
289         generic-getgenericarguments.2.cs        \
290         generic-type-builder.2.cs       \
291         generic-synchronized.2.cs       \
292         generic-delegate-ctor.2.cs      \
293         generic-array-iface-set.2.cs    \
294         generic-typedef.2.cs    \
295         generic-marshalbyref.2.cs       \
296         generic-xdomain.2.cs    \
297         bug-431413.2.cs \
298         bug-459285.2.cs \
299         generic-virtual-invoke.2.cs     \
300         bug-461198.2.cs \
301         generic-sealed-virtual.2.cs     \
302         generic-system-arrays.2.cs      \
303         generic-stack-traces.2.cs       \
304         generic-stack-traces2.2.cs      \
305         bug-472600.2.cs \
306         recursive-generics.2.cs \
307         bug-473482.2.cs \
308         bug-473999.2.cs \
309         bug-479763.2.cs \
310         bug-616463.cs   \
311         bug-80392.2.cs          \
312         dynamic-method-access.2.cs      \
313         dynamic-method-finalize.2.cs    \
314         bug-82194.2.cs  \
315         anonarray.2.cs  \
316         ienumerator-interfaces.2.cs     \
317         array-enumerator-ifaces.2.cs    \
318         generic_type_definition_encoding.2.cs \
319         generic_type_definition.2.cs    \
320         bug-333798.2.cs         \
321         bug-333798-tb.2.cs              \
322         bug-335131.2.cs         \
323         bug-322722_patch_bx.2.cs                \
324         bug-348522.2.cs         \
325         bug-340662_bug.cs       \
326         bug-322722_dyn_method_throw.2.cs        \
327         bug-389886-2.cs \
328         bug-325283.2.cs \
329         thunks.cs \
330         winx64structs.cs \
331         bug-349190.2.cs \
332         nullable_boxing.2.cs    \
333         valuetype-equals.cs     \
334         custom-modifiers.2.cs   \
335         bug-382986.cs   \
336         test-inline-call-stack.cs       \
337         bug-324535.cs   \
338         modules.cs      \
339         bug-81673.cs    \
340         bug-81691.cs    \
341         bug-80307.cs    \
342         bug-415577.cs   \
343         filter-stack.cs \
344         vararg2.cs      \
345         bug-389886-sre-generic-interface-instances.cs   \
346         bug-461867.cs   \
347         bug-461941.cs   \
348         bug-461261.cs   \
349         bug-400716.cs   \
350         bug-462592.cs   \
351         bug-459094.cs   \
352         generic-unloading.2.cs  \
353         generic-unloading-sub.2.cs      \
354         bug-467456.cs   \
355         appdomain-unload-callback.cs    \
356         bug-508538.cs   \
357         bug-472692.2.cs         \
358         gchandles.cs    \
359         interlocked-3.cs        \
360         interlocked-4.2.cs      \
361         finalizer-wait.cs       \
362         critical-finalizers.cs  \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs
386
387 TEST_CS_SRC_DIST=       \
388         $(BASE_TEST_CS_SRC)     \
389         async-exc-compilation.cs \
390         filter-stack.cs \
391         finally_guard.cs
392
393 TEST_CS_SRC_GEN = \
394         runtime-invoke.gen.cs \
395         imt_big_iface_test.cs
396         
397
398 if AMD64
399 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
400 # #651684
401 PLATFORM_DISABLED_TESTS = finally_guard.exe
402 else
403 if X86
404 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
405 else
406 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
407 endif
408 endif
409
410 if IA64
411 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
412 # bug #319249
413 PLATFORM_DISABLED_TESTS=exception17.exe
414 PLATFORM_DISABLED_TESTS+=winx64structs.exe
415 endif
416
417 if X86
418
419 if HOST_WIN32
420 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
421 endif
422
423 endif
424
425 if POWERPC
426 # bug #71274
427 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
428 endif
429
430 if ARM
431 PLATFORM_DISABLED_TESTS=filter-stack.exe
432 endif
433
434 if MIPS
435 # monitor.exe is racy
436 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
437 endif
438
439 if S390x
440 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
441 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
442 endif
443
444 # The two finalizer tests only work under sgen
445 # gc-altstack.exe fails under boehm because it has no support for altstack
446 # bug-459094.exe creates an extremely deep directory tree
447 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
448 # reverted.
449 # generic_type_definition.2.exe depends on COMPILER_ACCESS which is no longer supported.
450 DISABLED_TESTS=                 \
451         delegate-async-exception.exe    \
452         bug-348522.2.exe        \
453         finalizer-wait.exe      \
454         critical-finalizers.exe \
455         gc-altstack.exe \
456         bug-459094.exe \
457         delegate-invoke.exe \
458         generic_type_definition.2.exe \
459         $(PLATFORM_DISABLED_TESTS)
460
461 AOT_DISABLED_TESTS=constraints-load.exe
462
463 # These only compile with MS CSC
464 TEST_CSC_SRC=                   \
465         vararg.cs
466
467 TEST_IL_SRC=                    \
468         field-access.il         \
469         method-access.il        \
470         ldftn-access.il         \
471         cpblkTest.il            \
472         vbinterface.il          \
473         calliTest.il            \
474         ckfiniteTest.il         \
475         fault-handler.il                \
476         locallocTest.il         \
477         initblkTest.il          \
478         qt-instance.il          \
479         vararg.il               \
480         bug-29859.il            \
481         bug-78549.il            \
482         static-fields-nonconst.il       \
483         reload-at-bb-end.il     \
484         test-enum-indstoreil.il \
485         filter-bug.il           \
486         even-odd.il             \
487         bug-82022.il    \
488         vt-sync-method.il       \
489         enum_types.il   \
490         invalid-token.il        \
491         call_missing_method.il  \
492         call_missing_class.il   \
493         ldfld_missing_field.il  \
494         ldfld_missing_class.il  \
495         find-method.2.il        \
496         bug-79215.2.il  \
497         bug-79956.2.il  \
498         bug-327438.2.il \
499         bug-387274.2.il \
500         bug-426309.2.il \
501         ldtoken_with_byref_typespec.2.il \
502         resolve_method_bug.2.il \
503         resolve_field_bug.2.il \
504         resolve_type_bug.2.il   \
505         generics-sharing-other-exc.2.il \
506         generic-ldobj.2.il      \
507         generic-mkrefany.2.il   \
508         generic-refanyval.2.il  \
509         generic-ldtoken.2.il    \
510         generic-ldtoken-method.2.il     \
511         generic-ldtoken-field.2.il      \
512         generic-tailcall.2.il   \
513         generic-tailcall2.2.il  \
514         generic-array-exc.2.il  \
515         generic-valuetype-newobj2.2.il  \
516         generic-valuetype-newobj.2.il   \
517         generic-constrained.2.il        \
518         generic-type-load-exception.2.il        \
519         bug-81466.il    \
520         bug457574.il    \
521         bug445361.il    \
522         bug-463303.il   \
523         bug469742.2.il  \
524         bug-528055.il   \
525         constraints-load.il     \
526         array_load_exception.il \
527         bug-481403.il   \
528         interface-with-static-method.il \
529         bug-515884.il   \
530         bug-633291.il   \
531         delegate-with-null-target.il    \
532         bug-318677.il
533
534 # pre-requisite test sources: files that are not test themselves
535 # but that need to be compiled
536 PREREQ_IL_SRC=event-il.il module-cctor.il
537 PREREQ_CS_SRC=
538 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
539 PREREQ_CS_DLL_SRC=
540
541 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
542 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
543 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
544 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
545 TESTBS=$(BENCHSRC:.cs=.exe)
546 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
547
548 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
549         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
550
551 %.exe: %.il
552         $(ILASM) -out:$@ $<
553
554 %.exe: %.cs TestDriver.dll
555         $(MCS) -r:TestDriver.dll -out:$@ $<
556
557 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
558 if POWERPC
559 test_platform:
560 else
561 # Can't use mkbundle on win32 since there is no static build there
562 # Can't run test-unhandled-exception on Windows because of all the debug popups...
563 if HOST_WIN32
564 test_platform:
565 else
566 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
567 #test_platform: testbundle test-iomap-regression
568 test_platform:  test-iomap-regression
569 endif
570 endif
571
572 if X86
573 if HOST_WIN32
574 else
575 test_platform: test-eglib-remap
576 endif
577 endif
578
579 # Target to precompile the test executables
580 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
581
582 #
583 # Test that no symbols are missed in eglib-remap.h
584 #
585 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
586 test-eglib-remap:
587         @echo "Testing eglib remap..."
588         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
589
590 #
591 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
592 # code that checks that the table is properly sorted
593 #
594 test_messages: w32message.exe
595         > test_messages.zero
596         $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
597
598 if MOONLIGHT
599 test_2_1 : test-coreclr-security
600 else
601 test_2_1 :
602 endif
603
604 if AMD64
605 test-sgen : sgen-tests
606 else
607 if X86
608 test-sgen : sgen-tests
609 else
610 if ARM
611 test-sgen : sgen-tests
612 else
613 if S390x
614 test-sgen : sgen-regular-tests
615 endif
616 endif
617 endif
618 endif
619
620 # test_messages fails on the buildbots
621 #test: assemblyresolve/test/asm.dll testjit test-type-load test-generic-sharing test_platform test_2_1 test_messages
622 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen
623
624 assemblyresolve/test/asm.dll:
625         $(MAKE) -C assemblyresolve prereq
626
627 TestDriver.dll:
628         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
629
630 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
631         @failed=0; \
632         passed=0; \
633         for i in $(TESTSI_CS); do       \
634                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
635                 then \
636                         passed=`expr $${passed} + 1`; \
637                 else \
638                         if [ $$? = 2 ]; then break; fi; \
639                         failed=`expr $${failed} + 1`; \
640                 fi \
641         done; \
642         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
643
644 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
645         @failed=0; \
646         passed=0; \
647         for i in $(TESTSI_IL); do       \
648                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" $(RUNTIME_ARGS); \
649                 then \
650                         passed=`expr $${passed} + 1`; \
651                 else \
652                         if [ $$? = 2 ]; then break; fi; \
653                         failed=`expr $${failed} + 1`; \
654                 fi \
655         done; \
656         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
657
658 testb: $(TEST_PROG) $(TESTBS)
659         for i in $(TESTBS); do  \
660                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS);     \
661         done
662
663 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
664         @failed=0; \
665         passed=0; \
666         failed_tests="";\
667         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
668                 rm -f $${i}.so; \
669                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
670                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
671                 then \
672                         passed=`expr $${passed} + 1`; \
673                 else \
674                         if [ $$? = 2 ]; then break; fi; \
675                         failed=`expr $${failed} + 1`; \
676                         failed_tests="$${failed_tests} $$i"; \
677                 fi \
678         done; \
679         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
680         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
681           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
682
683 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
684         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
685
686 testjit:
687         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
688
689 testaot:
690         @$(MAKE) AOT=1 runtest
691
692 testtrace:
693         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
694
695 testinterp:
696         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
697
698 testjitspeed: $(JITTEST_PROG) $(TESTBS)
699         for i in $(TESTBS); do  \
700                 echo $$i;       \
701                 time $(JITTEST_PROG) $$i;       \
702         done
703
704 test-iomap-regression: exists.cs
705         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
706         @echo "Testing exists.exe..."
707         @MONO_IOMAP=all $(RUNTIME) exists.exe
708
709 stresstest: $(STRESS_TESTS)
710         @failed=0; \
711         passed=0; \
712         failed_tests="";\
713         for i in $(STRESS_TESTS); do    \
714                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
715                 then \
716                         passed=`expr $${passed} + 1`; \
717                 else \
718                         if [ $$? = 2 ]; then break; fi; \
719                         failed=`expr $${failed} + 1`; \
720                         failed_tests="$${failed_tests} $$i"; \
721                 fi \
722         done; \
723         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
724         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
725           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
726
727 testbundle: console.exe
728         @echo "Testing mkbundle..."
729         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
730         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
731         @- rm -rf a.out
732
733 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
734 test-type-load: TestDriver.dll
735         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
736         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
737         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
738         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
739         @echo "Testing load-exception.exe..."
740         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
741
742
743 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs
744
745 SGEN_TESTS =    \
746         sgen-descriptors.exe    \
747         sgen-gshared-vtype.exe
748
749 sgen-regular-tests: $(SGEN_TESTS)
750         @for fn in $+ ; do      \
751                 echo "Testing $$fn ...";        \
752                 MONO_GC_PARAMS=major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;        \
753                 MONO_ENV_OPTIONS="--gc=sgen"                                    $(RUNTIME) $$fn > $$fn.stdout || exit 1;        \
754                 MONO_GC_PARAMS=major=marksweep-par,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;    \
755                 MONO_GC_PARAMS=minor=split MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;    \
756                 MONO_GC_PARAMS=major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;   \
757                 MONO_GC_PARAMS=minor=split,major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;       \
758         done
759
760
761 sgen-tests: sgen-regular-tests sgen-bridge.exe sgen-bridge-major-fragmentation.exe
762         @echo "Testing sgen-bridge.exe ...";    \
763         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr
764         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr
765         @echo "Testing sgen-bridge-major-fragmentation.exe ...";        \
766         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr
767         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr
768
769
770 # Generated tests for runtime invoke
771 EXTRA_DIST += gen-runtime-invoke.cs
772 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
773         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
774         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
775
776 EXTRA_DIST += make-imt-test.cs
777 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
778         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
779         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
780
781 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
782 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
783         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
784 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
785         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
786
787 EXTRA_DIST += unhandled-exception-base-configuration.config
788 EXTRA_DIST += unhandled-exception-legacy-configuration.config
789 EXTRA_DIST += appdomain-unload.exe.config
790 EXTRA_DIST += unhandled-exception-test-case.2.cs
791 EXTRA_DIST += unhandled-exception-test-runner.2.cs
792 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
793         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
794 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
795         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
796 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
797         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
798 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
799         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
800         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
801         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
802         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
803 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
804         $(MCS) /debug unhandled-exception-test-case.1.cs
805 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
806         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
807 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
808         $(MCS) /debug unhandled-exception-test-case.2.cs
809 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
810         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
811 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
812         $(MCS) /debug unhandled-exception-test-runner.2.cs
813
814 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
815         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
816
817 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
818 bug-80307.exe: $(srcdir)/bug-80307.cs
819         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
820         cd $(top_builddir)/runtime && $(MAKE) test-support-files
821
822 EXTRA_DIST += bug-81673-interface.cs
823 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
824         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
825         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
826         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
827
828 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
829 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
830         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
831         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
832         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
833         rm -f bug-81691-a.dll
834 bug-81691.exe: bug-81691-b.dll
835
836 EXTRA_DIST += bug-81466-lib.il
837 bug-81466-lib.dll: bug-81466-lib.il
838         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
839 bug-81466.exe: bug-81466.il bug-81466-lib.dll
840         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
841
842 EXTRA_DIST += bug-324535-il.il
843 bug-324535-il.dll : bug-324535-il.il
844         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
845 bug-324535.exe : bug-324535.cs bug-324535-il.dll
846         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
847
848 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
849 custom-modifiers-lib.dll: custom-modifiers-lib.il
850         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
851 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
852         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
853
854 EXTRA_DIST += bug-382986-lib.cs
855 bug-382986-lib.dll: bug-382986-lib.cs
856         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
857 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
858         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
859
860 EXTRA_DIST += coreclr-security.cs
861
862 if MOONLIGHT
863 coreclr-security.exe : coreclr-security.cs
864         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
865
866 test-coreclr-security : coreclr-security.exe
867         @echo "Testing coreclr-security.exe..."
868         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
869 endif
870
871 EXTRA_DIST += generic-unboxing.2.il
872 generic-unboxing.2.dll : generic-unboxing.2.il
873         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
874
875 EXTRA_DIST += generic-boxing.2.il
876 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
877         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
878
879 EXTRA_DIST += generic-unbox.2.cs
880 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
881         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
882
883 EXTRA_DIST += generic-box.2.cs
884 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
885         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
886
887 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
888 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
889         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
890 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
891         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
892
893 bug-3903.exe: bug-3903.cs
894         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
895
896 gshared: test-generic-sharing
897
898 gshared-aot:
899         @$(MAKE) AOT=1 gshared
900
901 GSHARED_TESTS = \
902                 generics-sharing.2.exe shared-generic-methods.2.exe     \
903                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
904                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
905                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
906                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
907                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
908                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
909                 generic-virtual.2.exe generic-tailcall.2.exe                    \
910                 generic-interface-methods.2.exe generic-array-type.2.exe        \
911                 generic-method-patching.2.exe generic-static-methods.2.exe      \
912                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
913                 generic-array-exc.2.exe generic-special.2.exe                   \
914                 generic-exceptions.2.exe generic-delegate2.2.exe                \
915                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
916                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
917                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
918                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
919                 generic-constrained.2.exe bug-431413.2.exe                      \
920                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
921                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
922                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
923                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
924                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
925                 bug-479763.2.exe generic-xdomain.2.exe                          \
926                 generic-type-load-exception.2.exe bug-616463.exe        \
927                 bug-1147.exe
928
929 test-generic-sharing-normal: $(GSHARED_TESTS)
930         @for fn in $+ ; do      \
931                 echo "Testing $$fn ...";        \
932                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
933                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
934                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
935                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
936                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
937         done
938
939 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
940         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
941
942 test-generic-sharing:
943         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
944
945 EXTRA_DIST += async-exceptions.cs
946 async-exceptions.exe : async-exceptions.cs
947         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
948 test-async-exceptions : async-exceptions.exe
949         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
950         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
951
952 EXTRA_DIST += modules.cs modules-m1.cs
953 modules-m1.netmodule: modules-m1.cs
954         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
955 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
956         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
957
958 # Useful if mono is compiled with --enable-shared=no
959 patch-libtool:
960         cp "../../libtool" .
961         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
962         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
963         touch libtest.c
964
965 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
966 test-process-exit:
967         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
968         @echo "Testing bug-438454.exe..."
969         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
970         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
971
972 OOM_TESTS =     \
973         gc-oom-handling.exe     \
974         gc-oom-handling2.exe
975
976
977 test-oom: $(OOM_TESTS)
978         @for fn in $+ ; do      \
979                 echo "Testing $$fn ...";        \
980                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
981                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
982                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
983         done
984
985
986 noinst_LTLIBRARIES = libtest.la
987
988 INCLUDES = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
989
990 if HOST_WIN32
991 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
992 # This shows up when compiling mono_test_marshal_delegate ()
993 libtest_la_CFLAGS=-fno-optimize-sibling-calls
994 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
995 # can't find them. So we use --kill-at to remove the @ suffix as well.
996 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
997 else
998 libtest_la_LDFLAGS = -rpath `pwd`
999 endif
1000 libtest_la_SOURCES = libtest.c
1001 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1002
1003 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat